/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 2 -*- */
/* gdome-xml-util.c
 *
 * Copyright (C) 1999 Raph Levien <raph@acm.org>
 * Copyright (C) 2000 Mathieu Lacage <mathieu@gnu.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */

#include <stdlib.h>
#include <string.h>
#include <tree.h>
#include <parser.h>
#include <xmlmemory.h>
#include "gdome.h"
#include "gdome-util.h"
#include "gdome-xml-node.h"
#include "gdome-xml-element.h"
#include "gdome-evt-eventl.h"
#include "gdome-xml-util.h"


GdomeNode *
gdome_xml_cast_node (Gdome_xml_Node *node)
{
	if (node == NULL)
		return NULL;
	g_return_val_if_fail (GDOME_XML_IS_N(node), NULL);

	return (GdomeNode *) node;
}


GdomeElement *
gdome_xml_cast_el (Gdome_xml_Element *el)
{
	if (el == NULL)
		return NULL;
	g_return_val_if_fail (GDOME_XML_IS_EL(el), NULL);

	return (GdomeElement *) el;
}


GdomeEventTarget *
gdome_xml_cast_evntt (GdomeEventTarget *evntt)
{
	if (evntt == NULL)
		return NULL;
	g_return_val_if_fail (GDOME_XML_IS_EVNTT(evntt), NULL);
	
	return (GdomeEventTarget *) evntt;
}


GdomeEventListener *
gdome_xml_cast_evntl (Gdome_evt_EventListener *evntl)
{
	if (evntl == NULL)
		return NULL;
	g_return_val_if_fail (GDOME_XML_IS_EVNTL(evntl), NULL);
	
	return (GdomeEventListener *) evntl;
}
